Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::FieldValueHitQueue Class Reference

A hit queue for sorting by hits by terms in more than one field. Uses FieldCache::DEFAULT for maintaining internal term lookup tables. More...

`#include <FieldValueHitQueue.h>`

Inheritance diagram for Lucene::FieldValueHitQueue:

## Public Member Functions

virtual | ~FieldValueHitQueue ()
virtual String | getClassName ()
boost::shared_ptr< FieldValueHitQueue > | shared_from_this ()
Collection< FieldComparatorPtr > | getComparators ()
Collection< int32_t > | getReverseMul ()
FieldDocPtr | fillFields (const FieldValueHitQueueEntryPtr &entry)
| Given a queue Entry, creates a corresponding FieldDoc that contains the values used to sort the given document. These values are not the raw values out of the index, but the internal representation of them. This is so the given search hit can be collated by a MultiSearcher with other search hits. More...
Collection< SortFieldPtr > | getFields ()
| Returns the SortFields being used by this hit queue. More...
Public Member Functions inherited from Lucene::HitQueueBase
| HitQueueBase (int32_t size)
virtual | ~HitQueueBase ()
boost::shared_ptr< HitQueueBase > | shared_from_this ()
virtual ScoreDocPtr | add (const ScoreDocPtr &scoreDoc)
virtual ScoreDocPtr | addOverflow (const ScoreDocPtr &scoreDoc)
virtual ScoreDocPtr | top ()
virtual ScoreDocPtr | pop ()
virtual ScoreDocPtr | updateTop ()
virtual int32_t | size ()
virtual bool | empty ()
virtual void | clear ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
static FieldValueHitQueuePtr | create (Collection< SortFieldPtr > fields, int32_t size)
| Creates a hit queue sorted by the given list of fields. More...
Static Public Member Functions inherited from Lucene::HitQueueBase
static String | _getClassName ()

## Protected Member Functions

| FieldValueHitQueue (Collection< SortFieldPtr > fields, int32_t size)
Protected Member Functions inherited from Lucene::HitQueueBase
virtual bool | lessThan (const ScoreDocPtr &first, const ScoreDocPtr &second)=0
virtual ScoreDocPtr | getSentinelObject ()
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

Collection< SortFieldPtr > | fields
| Stores the sort criteria being used. More...
Collection< FieldComparatorPtr > | comparators
Collection< int32_t > | reverseMul
Protected Attributes inherited from Lucene::HitQueueBase
PriorityQueueScoreDocsPtr | queue
int32_t | queueSize
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

A hit queue for sorting by hits by terms in more than one field. Uses FieldCache::DEFAULT for maintaining internal term lookup tables.

See also
  Searcher::search(QueryPtr, FilterPtr, int32_t, SortPtr)
  FieldCache

## Constructor & Destructor Documentation

Lucene::FieldValueHitQueue::FieldValueHitQueue | ( | Collection< SortFieldPtr > | fields,
|  | int32_t | size
| ) |  |

protected

virtual Lucene::FieldValueHitQueue::~FieldValueHitQueue | ( |  | ) |

virtual

## Member Function Documentation

static String Lucene::FieldValueHitQueue::_getClassName | ( |  | ) |

inline static

static FieldValueHitQueuePtr Lucene::FieldValueHitQueue::create | ( | Collection< SortFieldPtr > | fields,
|  | int32_t | size
| ) |  |

static

Creates a hit queue sorted by the given list of fields.

Parameters

  fields | SortField array we are sorting by in priority order (highest priority first); cannot be null or empty.
  size | The number of hits to retain. Must be greater than zero.

FieldDocPtr Lucene::FieldValueHitQueue::fillFields | ( | const FieldValueHitQueueEntryPtr & | entry | ) |

Given a queue Entry, creates a corresponding FieldDoc that contains the values used to sort the given document. These values are not the raw values out of the index, but the internal representation of them. This is so the given search hit can be collated by a MultiSearcher with other search hits.

Parameters

  entry | The Entry used to create a FieldDoc

Returns
  The newly created FieldDoc

See also
  Searchable::search(WeightPtr, FilterPtr, int32_t, SortPtr)

virtual String Lucene::FieldValueHitQueue::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::HitQueueBase.

Collection<FieldComparatorPtr> Lucene::FieldValueHitQueue::getComparators | ( |  | ) |

Collection<SortFieldPtr> Lucene::FieldValueHitQueue::getFields | ( |  | ) |

Returns the SortFields being used by this hit queue.

Collection<int32_t> Lucene::FieldValueHitQueue::getReverseMul | ( |  | ) |

boost::shared_ptr< FieldValueHitQueue > Lucene::FieldValueHitQueue::shared_from_this | ( |  | ) |

inline

## Field Documentation

Collection<FieldComparatorPtr> Lucene::FieldValueHitQueue::comparators

protected

Collection<SortFieldPtr> Lucene::FieldValueHitQueue::fields

protected

Stores the sort criteria being used.

Collection<int32_t> Lucene::FieldValueHitQueue::reverseMul

protected

The documentation for this class was generated from the following file:

- FieldValueHitQueue.h

clucene.sourceforge.net